<div class="row" v-if="loading_activities == false && activities_suggestions.length > 0">
	<legend class="mb-3">Actividades para agregar a tu estadía</legend>
	<div class="container-fluid">
	    <div id="carousel_activities" class="carousel slide" data-ride="carousel" data-interval="9000">
	        <div class="carousel-inner row w-100 mx-auto" role="listbox">
	            <div class="carousel-item col-md-4 active" v-for="(activity, index) in activities_suggestions" v-if="index == 0">
	                <div class="tour_container">
						<!-- <div class="ribbon_3 popular"><span>Popular</span></div> -->
			            <div class="img_container">
			                <a :href="baseUrl+'/activities/details?codeActivity='+activity.activity.code+'&dates='+info_search.fecha_ini+'_'+info_search.fecha_fin" target="_blank">
			                <img :src="activity.activity.content.media.images[0].urls[3].resource" width="800" height="533" class="img-fluid" alt="Image">
			                    <div class="short_info" v-text="activity.activity.country.destinations[0].name + ', ' + activity.activity.country.name"></div>
			                </a>
			            </div>
			            <div class="tour_title">
			                <h3><strong v-text="activity.activity.name"></strong></h3>
			                <table>
			                	<tr>
			                		<td>Desde</td>
			                		<td v-text="'$ ' + printTotalActivity(activity.activity.modalities[0], index) + ' ' + activity.activity.currency"></td>
			                	</tr>
			                </table>
			            </div>
					</div><!-- End box tour -->
	            </div>
	            <div class="carousel-item col-md-4" v-else>
	                <div class="tour_container">
						<!-- <div class="ribbon_3 popular"><span>Popular</span></div> -->
			            <div class="img_container">
			                <a :href="baseUrl+'/activities/details?codeActivity='+activity.activity.code+'&dates='+info_search.fecha_ini+'_'+info_search.fecha_fin" target="_blank">
			                <img :src="activity.activity.content.media.images[0].urls[3].resource" width="800" height="533" class="img-fluid" alt="Image">
			                    <div class="short_info" v-text="activity.activity.country.destinations[0].name + ', ' + activity.activity.country.name"></div>
			                </a>
			            </div>
			            <div class="tour_title">
			                <h3><strong v-text="activity.activity.name"></strong></h3>
			                <table>
			                	<tr>
			                		<td>Desde</td>
			                		<td v-text="'$ ' + printTotalActivity(activity.activity.modalities[0], index) + ' ' + activity.activity.currency"></td>
			                	</tr>
			                </table>
			            </div>
					</div><!-- End box tour -->
	            </div>
	        </div>
	        <a class="carousel-control-prev" href="#carousel_activities" role="button" data-slide="prev">
	            <i class="fa fa-chevron-left fa-lg text-muted"></i>
	            <span class="sr-only">Previous</span>
	        </a>
	        <a class="carousel-control-next text-faded" href="#carousel_activities" role="button" data-slide="next">
	            <i class="fa fa-chevron-right fa-lg text-muted"></i>
	            <span class="sr-only">Next</span>
	        </a>
	    </div>
	</div>
</div>
<div v-else-if="loading_activities == true">
	<legend>Cargando sugerencias para actividades... <span class="icon-spin6 animate-spin"></span></legend>
</div>
<div v-else>
	<legend>No hay sugerencias para actividades en este destino.</legend>
</div>

<hr>

<div class="row" v-if="loading_tours == false && tour_suggestions.length > 0">
	<legend class="mb-3">Tours para agregar a tu estadía</legend>
	<div class="container-fluid">
	    <div id="carousel_tours" class="carousel slide" data-ride="carousel" data-interval="9000">
	        <div class="carousel-inner row w-100 mx-auto" role="listbox">
	            <div class="carousel-item col-md-4 active" v-for="(tour, index) in tour_suggestions" v-if="index == 0">
	                <div class="tour_container">
						<!-- <div class="ribbon_3 popular"><span>Popular</span></div> -->
			            <div class="img_container">
			                <a :href="baseUrl+'/site/tours?destino=t_'+tour.id_tour+url_tour" target="_blank">
			                <img :src="'https://www.rutamayatravel.com/imagenes/tours/' + tour.imagen" width="800" height="533" class="img-fluid" alt="Image">
			                    <div class="short_info" v-text=""></div>
			                </a>
			            </div>
			            <div class="tour_title">
			                <h3><strong v-text="tour.nombre"></strong></h3>
			                <table>
			                	<tr>
			                		<td>Desde</td>
			                		<td v-text="'$ ' + printTotalTour(tour.tarifas[0]) + ' ' + tour.tarifas[0].moneda"></td>
			                	</tr>
			                </table>
			            </div>
					</div><!-- End box tour -->
	            </div>
	            <div class="carousel-item col-md-4" v-else>
	                <div class="tour_container">
						<!-- <div class="ribbon_3 popular"><span>Popular</span></div> -->
			            <div class="img_container">
			                <a href="baseUrl+'/site/tours?destino=t_'+tour.id_tour+url_tour" target="_blank">
			                <img :src="'https://www.rutamayatravel.com/imagenes/tours/' + tour.imagen" width="800" height="533" class="img-fluid" alt="Image">
			                    <div class="short_info" v-text=""></div>
			                </a>
			            </div>
			            <div class="tour_title">
			                <h3><strong v-text="tour.nombre"></strong></h3>
			                <table>
			                	<tr>
			                		<td>Desde</td>
			                		<td v-text="'$ ' + printTotalTour(tour.tarifas[0]) + ' ' + tour.tarifas[0].moneda"></td>
			                	</tr>
			                </table>
			            </div>
					</div><!-- End box tour -->
	            </div>
	        </div>
	        <a class="carousel-control-prev" href="#carousel_tours" role="button" data-slide="prev">
	            <i class="fa fa-chevron-left fa-lg text-muted"></i>
	            <span class="sr-only">Previous</span>
	        </a>
	        <a class="carousel-control-next text-faded" href="#carousel_tours" role="button" data-slide="next">
	            <i class="fa fa-chevron-right fa-lg text-muted"></i>
	            <span class="sr-only">Next</span>
	        </a>
	    </div>
	</div>
</div>
<div v-else-if="loading_tours == true">
	<legend>Cargando sugerencias para tours... <span class="icon-spin6 animate-spin"></span></legend>
</div>
<div v-else>
	<legend>No hay sugerencias para tour en este destino.</legend>
</div>

<?php Yii::app()->clientScript->registerCssFile('https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.9.0/css/all.css'); ?>